import{Browser as BrowserBase,WEB_PERMISSION_TO_PROTOCOL_PERMISSION}from"../api/Browser.js";import{BrowserContext}from"../api/BrowserContext.js";import{assert}from"../util/assert.js";import{ChromeTargetManager}from"./ChromeTargetManager.js";import{ConnectionEmittedEvents}from"./Connection.js";import{FirefoxTargetManager}from"./FirefoxTargetManager.js";import{InitializationStatus,OtherTarget,PageTarget,WorkerTarget}from"./Target.js";import{TaskQueue}from"./TaskQueue.js";export class CDPBrowser extends BrowserBase{static async _create(t,e,r,a,s,i,n,o,g,c=!0){const h=new CDPBrowser(t,e,r,a,s,i,n,o,g,c);return await h._attach(),h}#t;#e;#r;#a;#s;#i;#n;#o;#g=new Map;#c;#h;get _targets(){return this.#h.getAvailableTargets()}constructor(t,e,r,a,s,i,n,o,g,c=!0){super(),t=t||"chrome",this.#t=a,this.#e=s,this.#r=i,this.#c=new TaskQueue,this.#a=e,this.#s=n||function(){},this.#i=o||(()=>!0),this.#d(g),this.#h="firefox"===t?new FirefoxTargetManager(e,this.#l,this.#i):new ChromeTargetManager(e,this.#l,this.#i,c),this.#o=new CDPBrowserContext(this.#a,this);for(const t of r)this.#g.set(t,new CDPBrowserContext(this.#a,this,t))}#w=()=>{this.emit("disconnected")};async _attach(){this.#a.on(ConnectionEmittedEvents.Disconnected,this.#w),this.#h.on("targetAvailable",this.#C),this.#h.on("targetGone",this.#u),this.#h.on("targetChanged",this.#T),this.#h.on("targetDiscovered",this.#f),await this.#h.initialize()}_detach(){this.#a.off(ConnectionEmittedEvents.Disconnected,this.#w),this.#h.off("targetAvailable",this.#C),this.#h.off("targetGone",this.#u),this.#h.off("targetChanged",this.#T),this.#h.off("targetDiscovered",this.#f)}process(){return this.#r??null}_targetManager(){return this.#h}#d(t){this.#n=t||(t=>"page"===t.type()||"background_page"===t.type()||"webview"===t.type())}_getIsPageTargetCallback(){return this.#n}async createIncognitoBrowserContext(t={}){const{proxyServer:e,proxyBypassList:r}=t,{browserContextId:a}=await this.#a.send("Target.createBrowserContext",{proxyServer:e,proxyBypassList:r&&r.join(",")}),s=new CDPBrowserContext(this.#a,this,a);return this.#g.set(a,s),s}browserContexts(){return[this.#o,...Array.from(this.#g.values())]}defaultBrowserContext(){return this.#o}async _disposeContext(t){t&&(await this.#a.send("Target.disposeBrowserContext",{browserContextId:t}),this.#g.delete(t))}#l=(t,e)=>{const{browserContextId:r}=t,a=r&&this.#g.has(r)?this.#g.get(r):this.#o;if(!a)throw new Error("Missing browser context");const s=e=>this.#a._createSession(t,e),i=new OtherTarget(t,e,a,this.#h,s);return this.#n(i)?new PageTarget(t,e,a,this.#h,s,this.#t,this.#e??null,this.#c):"service_worker"===t.type||"shared_worker"===t.type?new WorkerTarget(t,e,a,this.#h,s):new OtherTarget(t,e,a,this.#h,s)};#C=async t=>{await t._initializedDeferred.valueOrThrow()===InitializationStatus.SUCCESS&&(this.emit("targetcreated",t),t.browserContext().emit("targetcreated",t))};#u=async t=>{t._initializedDeferred.resolve(InitializationStatus.ABORTED),t._isClosedDeferred.resolve(),await t._initializedDeferred.valueOrThrow()===InitializationStatus.SUCCESS&&(this.emit("targetdestroyed",t),t.browserContext().emit("targetdestroyed",t))};#T=({target:t})=>{this.emit("targetchanged",t),t.browserContext().emit("targetchanged",t)};#f=t=>{this.emit("targetdiscovered",t)};wsEndpoint(){return this.#a.url()}async newPage(){return this.#o.newPage()}async _createPageInContext(t){const{targetId:e}=await this.#a.send("Target.createTarget",{url:"about:blank",browserContextId:t||void 0}),r=this.#h.getAvailableTargets().get(e);if(!r)throw new Error(`Missing target for page (id = ${e})`);if(!(await r._initializedDeferred.valueOrThrow()===InitializationStatus.SUCCESS))throw new Error(`Failed to create target for page (id = ${e})`);const a=await r.page();if(!a)throw new Error(`Failed to create a page for context (id = ${t})`);return a}targets(){return Array.from(this.#h.getAvailableTargets().values()).filter((t=>t._initializedDeferred.value()===InitializationStatus.SUCCESS))}target(){const t=this.targets().find((t=>"browser"===t.type()));if(!t)throw new Error("Browser target is not found");return t}async version(){return(await this.#p()).product}async userAgent(){return(await this.#p()).userAgent}async close(){await this.#s.call(null),this.disconnect()}disconnect(){this.#h.dispose(),this.#a.dispose(),this._detach()}isConnected(){return!this.#a._closed}#p(){return this.#a.send("Browser.getVersion")}}export class CDPBrowserContext extends BrowserContext{#a;#x;#b;constructor(t,e,r){super(),this.#a=t,this.#x=e,this.#b=r}get id(){return this.#b}targets(){return this.#x.targets().filter((t=>t.browserContext()===this))}waitForTarget(t,e={}){return this.#x.waitForTarget((e=>e.browserContext()===this&&t(e)),e)}async pages(){return(await Promise.all(this.targets().filter((t=>"page"===t.type()||"other"===t.type()&&this.#x._getIsPageTargetCallback()?.(t))).map((t=>t.page())))).filter((t=>!!t))}isIncognito(){return!!this.#b}async overridePermissions(t,e){const r=e.map((t=>{const e=WEB_PERMISSION_TO_PROTOCOL_PERMISSION.get(t);if(!e)throw new Error("Unknown permission: "+t);return e}));await this.#a.send("Browser.grantPermissions",{origin:t,browserContextId:this.#b||void 0,permissions:r})}async clearPermissionOverrides(){await this.#a.send("Browser.resetPermissions",{browserContextId:this.#b||void 0})}newPage(){return this.#x._createPageInContext(this.#b)}browser(){return this.#x}async close(){assert(this.#b,"Non-incognito profiles cannot be closed!"),await this.#x._disposeContext(this.#b)}}