import{assert}from"../util/assert.js";import{Deferred}from"../util/Deferred.js";import{debug}from"./Debug.js";import{TargetCloseError,ProtocolError}from"./Errors.js";import{EventEmitter}from"./EventEmitter.js";import{debugError}from"./util.js";const debugProtocolSend=debug("puppeteer:protocol:SEND ►"),debugProtocolReceive=debug("puppeteer:protocol:RECV ◀");export const ConnectionEmittedEvents={Disconnected:Symbol("Connection.Disconnected")};function createIncrementalIdGenerator(){let e=0;return()=>++e}export class Callback{#e;#t=new ProtocolError;#s=Deferred.create();#r;#o;constructor(e,t,s){this.#e=e,this.#o=t,s&&(this.#r=setTimeout((()=>{this.#s.reject(rewriteError(this.#t,`${t} timed out. Increase the 'protocolTimeout' setting in launch/connect calls for a higher timeout if needed.`))}),s))}resolve(e){clearTimeout(this.#r),this.#s.resolve(e)}reject(e){clearTimeout(this.#r),this.#s.reject(e)}get id(){return this.#e}get promise(){return this.#s}get error(){return this.#t}get label(){return this.#o}}export class CallbackRegistry{#i=new Map;#n=createIncrementalIdGenerator();create(e,t,s){const r=new Callback(this.#n(),e,t);this.#i.set(r.id,r);try{s(r.id)}catch(e){throw r.promise.valueOrThrow().catch(debugError).finally((()=>{this.#i.delete(r.id)})),r.reject(e),e}return r.promise.valueOrThrow().finally((()=>{this.#i.delete(r.id)}))}reject(e,t,s){const r=this.#i.get(e);r&&this._reject(r,t,s)}_reject(e,t,s){const r=t instanceof ProtocolError,o=r?t.message:t,i=r?t:e.error;e.reject(rewriteError(i,`Protocol error (${e.label}): ${o}`,s))}resolve(e,t){const s=this.#i.get(e);s&&s.resolve(t)}clear(){for(const e of this.#i.values())this._reject(e,new TargetCloseError("Target closed"));this.#i.clear()}}export class Connection extends EventEmitter{#a;#c;#l;#d;#h=new Map;#m=!1;#u=new Set;#i=new CallbackRegistry;constructor(e,t,s=0,r){super(),this.#a=e,this.#l=s,this.#d=r??18e4,this.#c=t,this.#c.onmessage=this.onMessage.bind(this),this.#c.onclose=this.#g.bind(this)}static fromSession(e){return e.connection()}get timeout(){return this.#d}get _closed(){return this.#m}get _sessions(){return this.#h}session(e){return this.#h.get(e)||null}url(){return this.#a}send(e,...t){const s=t.length?t[0]:void 0;return this._rawSend(this.#i,e,s)}_rawSend(e,t,s,r){return e.create(t,this.#d,(e=>{const o=JSON.stringify({method:t,params:s,id:e,sessionId:r});debugProtocolSend(o),this.#c.send(o)}))}async closeBrowser(){await this.send("Browser.close")}async onMessage(e){this.#l&&await new Promise((e=>setTimeout(e,this.#l))),debugProtocolReceive(e);const t=JSON.parse(e);if("Target.attachedToTarget"===t.method){const e=t.params.sessionId,s=new CDPSessionImpl(this,t.params.targetInfo.type,e,t.sessionId);this.#h.set(e,s),this.emit("sessionattached",s);const r=this.#h.get(t.sessionId);r&&r.emit("sessionattached",s)}else if("Target.detachedFromTarget"===t.method){const e=this.#h.get(t.params.sessionId);if(e){e._onClosed(),this.#h.delete(t.params.sessionId),this.emit("sessiondetached",e);const s=this.#h.get(t.sessionId);s&&s.emit("sessiondetached",e)}}if(t.sessionId){const e=this.#h.get(t.sessionId);e&&e._onMessage(t)}else t.id?t.error?this.#i.reject(t.id,createProtocolErrorMessage(t),t.error.message):this.#i.resolve(t.id,t.result):this.emit(t.method,t.params)}#g(){if(!this.#m){this.#m=!0,this.#c.onmessage=void 0,this.#c.onclose=void 0,this.#i.clear();for(const e of this.#h.values())e._onClosed();this.#h.clear(),this.emit(ConnectionEmittedEvents.Disconnected)}}dispose(){this.#g(),this.#c.close()}isAutoAttached(e){return!this.#u.has(e)}async _createSession(e,t=!0){t||this.#u.add(e.targetId);const{sessionId:s}=await this.send("Target.attachToTarget",{targetId:e.targetId,flatten:!0});this.#u.delete(e.targetId);const r=this.#h.get(s);if(!r)throw new Error("CDPSession creation failed.");return r}async createSession(e){return await this._createSession(e,!1)}}export const CDPSessionEmittedEvents={Disconnected:Symbol("CDPSession.Disconnected")};export class CDPSession extends EventEmitter{constructor(){super()}connection(){throw new Error("Not implemented")}parentSession(){}send(){throw new Error("Not implemented")}async detach(){throw new Error("Not implemented")}id(){throw new Error("Not implemented")}}export class CDPSessionImpl extends CDPSession{#p;#b;#i=new CallbackRegistry;#f;#E;constructor(e,t,s,r){super(),this.#f=e,this.#b=t,this.#p=s,this.#E=r}connection(){return this.#f}parentSession(){if(!this.#E)return;const e=this.#f?.session(this.#E);return e??void 0}send(e,...t){if(!this.#f)return Promise.reject(new TargetCloseError(`Protocol error (${e}): Session closed. Most likely the ${this.#b} has been closed.`));const s=t.length?t[0]:void 0;return this.#f._rawSend(this.#i,e,s,this.#p)}_onMessage(e){e.id?e.error?this.#i.reject(e.id,createProtocolErrorMessage(e),e.error.message):this.#i.resolve(e.id,e.result):(assert(!e.id),this.emit(e.method,e.params))}async detach(){if(!this.#f)throw new Error(`Session already detached. Most likely the ${this.#b} has been closed.`);await this.#f.send("Target.detachFromTarget",{sessionId:this.#p})}_onClosed(){this.#i.clear(),this.#f=void 0,this.emit(CDPSessionEmittedEvents.Disconnected)}id(){return this.#p}}function createProtocolErrorMessage(e){let t=`${e.error.message}`;return e.error&&"object"==typeof e.error&&"data"in e.error&&(t+=` ${e.error.data}`),t}function rewriteError(e,t,s){return e.message=t,e.originalMessage=s??e.originalMessage,e}export function isTargetClosedError(e){return e instanceof TargetCloseError}