export default{cssContent:'/*\n * Copyright (C) 2009 Apple Inc.  All rights reserved.\n *\n * Redistribution and use in source and binary forms, with or without\n * modification, are permitted provided that the following conditions\n * are met:\n *\n * 1.  Redistributions of source code must retain the above copyright\n *     notice, this list of conditions and the following disclaimer.\n * 2.  Redistributions in binary form must reproduce the above copyright\n *     notice, this list of conditions and the following disclaimer in the\n *     documentation and/or other materials provided with the distribution.\n * 3.  Neither the name of Apple Computer, Inc. ("Apple") nor the names of\n *     its contributors may be used to endorse or promote products derived\n *     from this software without specific prior written permission.\n *\n * THIS SOFTWARE IS PROVIDED BY APPLE AND ITS CONTRIBUTORS "AS IS" AND ANY\n * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED\n * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE\n * DISCLAIMED. IN NO EVENT SHALL APPLE OR ITS CONTRIBUTORS BE LIABLE FOR ANY\n * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES\n * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;\n * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND\n * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT\n * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF\n * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.\n */\n\n.webkit-css-property {\n  color: var(--webkit-css-property-color, var(--sys-color-token-property-special)); /* stylelint-disable-line plugin/use_theme_colors */ /* See: crbug.com/1152736 for color variable migration. */\n}\n\n.webkit-html-comment {\n  color: var(--sys-color-token-comment);\n}\n\n.webkit-html-tag {\n  color: var(--sys-color-token-tag);\n}\n\n.webkit-html-tag-name,\n.webkit-html-close-tag-name {\n  /* Keep this in sync with view-source.css (.webkit-html-tag) */\n  color: var(--sys-color-token-tag);\n}\n\n.webkit-html-pseudo-element {\n  /* This one is non-standard. */\n  color: var(--sys-color-token-pseudo-element);\n}\n\n.webkit-html-js-node,\n.webkit-html-css-node {\n  color: var(--text-primary);\n  white-space: pre-wrap;\n}\n\n.webkit-html-text-node {\n  color: var(--text-primary);\n  unicode-bidi: -webkit-isolate;\n}\n\n.webkit-html-entity-value {\n  /* This one is non-standard. */\n  background-color: rgb(0 0 0 / 15%); /* stylelint-disable-line plugin/use_theme_colors */\n  /* See: crbug.com/1152736 for color variable migration. */\n  unicode-bidi: -webkit-isolate;\n}\n\n.webkit-html-doctype {\n  /* Keep this in sync with view-source.css (.webkit-html-doctype) */\n  color: var(--text-secondary);\n  /* See: crbug.com/1152736 for color variable migration. */\n}\n\n.webkit-html-attribute-name {\n  /* Keep this in sync with view-source.css (.webkit-html-attribute-name) */\n  color: var(--sys-color-token-attribute);\n  unicode-bidi: -webkit-isolate;\n}\n\n.webkit-html-attribute-value {\n  /* Keep this in sync with view-source.css (.webkit-html-attribute-value) */\n  color: var(--sys-color-token-attribute-value);\n  unicode-bidi: -webkit-isolate;\n  word-break: break-all;\n}\n\n.devtools-link {\n  color: var(--text-link);\n  text-decoration: underline;\n  outline-offset: 2px;\n\n  .elements-disclosure & {\n    color: var(--text-link);\n  }\n\n  [is="ui-icon"] {\n    vertical-align: middle;\n  }\n\n  [is="ui-icon"].icon-mask {\n    background-color: var(--color-link);\n  }\n\n  :focus .selected & [is="ui-icon"].icon-mask {\n    background-color: var(--legacy-item-selection-bg-color);\n  }\n\n  &:focus-visible {\n    outline-width: unset;\n  }\n\n  &:not(.devtools-link-prevent-click) {\n    cursor: pointer;\n  }\n\n  @media (forced-colors: active) {\n    &:not(.devtools-link-prevent-click) {\n      forced-color-adjust: none;\n      color: linktext;\n    }\n\n    &:focus-visible {\n      background: Highlight;\n      color: HighlightText;\n    }\n  }\n}\n'};